pro count_map_occurrences

;Read in data
openr,1,'data/mdiv_patch.dat'
data=dblarr(8,83213)
readf,1,data
close,1

; the total number of degrees
nlon=360L
nlat=180L
print,'nlon=',nlon,' nlat=',nlat,' nlon*nlat=',nlon*nlat

set_plot,'z'
;set_plot,'ps'
loadct,27
tvlct,RedTab,GreenTab,BlueTab,/get
RedTab(1)=0
GreenTab(1)=0
BlueTab(1)=0
tvlct,RedTab,GreenTab,BlueTab
device,set_font='Helvetica',/tt_font,set_character_size=[12,14],set_graphics_function=3L,set_resolution=[500,300],z_buffering=0
;device,/encapsulated,/color,bits=24,font_size=12,/helvetica,/bold,file='images/count_map.eps'
;
lat=reform(data(1,*))
lon=reform(data(2,*))
ndata = n_elements(lat)
print,'ndata=',ndata
x=dindgen(nlon)-179.5
y=dindgen(nlat)-89.5
zc=dblarr(nlon,nlat)
; The following loop that searches each one-degree lat/lon 
; cell and sums the number of unique genus names in that cell
for mlon=0,nlon-1 do begin
   for mlat=0,nlat-1 do begin
      idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
      zc[mlon,mlat] = cnt
      if cnt gt 0 then begin
         print,'lon=',x[mlon],' lat=',y[mlat],' cnt=',cnt
      endif
   endfor
endfor
zmin = min(zc[where(zc gt 0)])
zmax = max(zc[where(zc gt 0)])
print,'min(zc)=',zmin,' max(zc)=',zmax,' total(zc)=',total(zc)
;
tv_data=bytscl(zc,max=zmax,min=zmin,top=251)+3
idx = where(zc eq 0,cnt)
if cnt gt 0 then tv_data[idx] = 255
map_set,0,0,/robinson,/isotropic,title='Counts of Alpha Diversity',color=1
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/coasts,color=1
map_horizon,color=1
map_legend,zmin,zmax
;
map=tvrd()
write_gif,'images/count_map_occurrences.gif',map,RedTab,GreenTab,BlueTab
;
return
end
