pro pca

;Read in data
openr,1,'data/mdiv_patch.dat'
data=dblarr(17,83213)
readf,1,data
close,1

;water depth (standardized)
;x=transpose(standardize(data[3,*]))
x=transpose(standardize(data[7,*]))
;convert depth to a percentage first
;x=transpose((x/max(x))*100)
;percent sand (standardized)
y1=transpose(standardize(data[3,*]))
;percent silt (standardized)
y2=transpose(standardize(data[4,*]))
;percent clay (standardized)
y3=transpose(standardize(data[5,*]))
;percent lime mud (standardized)
y4=transpose(standardize(data[6,*]))
; Retain the means in case you need to regenerate the original data.
xmean = x - mean(x, /double)
y1mean = y1 - mean(y1, /double)
y2mean = y2 - mean(y2, /double)
y3mean = y3 - mean(y3, /double)
y4mean = y4 - mean(y4, /double)
array=transpose([[x], [y1], [y2], [y3], [y4]])
;Covariance Matrix
cm=correlate(array, /COVARIANCE, /double)
print,cm
eigenvalues = EIGENQL(cm, EIGENVECTORS=eigenvectors, /double)
print,'Eigenvalues'
print, eigenvalues
print,'Percent of Total Covariance in Each Eigenvector'
print, (eigenvalues / total(eigenvalues)) * 100
print,'Eigenvectors'
print, eigenvectors
;
;Feature Vector
print,'Outputting all 5 principal components'
fv=eigenvectors
;print,'Outputting only the 1st, 2nd, and 3rd principal component eigenvector rows'
;Feature Vector
;fv=eigenvectors[*,0:2]
;Final Data
fd=fv ## transpose(array)
rd = fd + rebin([mean(x, /double), mean(y1, /double), mean(y2, /double), mean(y3, /double), mean(y4, /double)], 5, 83213)
;
;Only the three most important dimensions
;Rotated Data
;rd=fd + rebin([mean(x, /double), mean(y1, /double), mean(y2, /double)], 3, 83213)
;
; Rotated Data for K-means analysis
;rd_2=dblarr(3,83213)
rd_2=dblarr(5,83213)
rd_2[0,*]=transpose(rd[*,0])
rd_2[1,*]=transpose(rd[*,1])
rd_2[2,*]=transpose(rd[*,2])
rd_2[3,*]=transpose(rd[*,3])
rd_2[4,*]=transpose(rd[*,4])
openw,1,'~/clust/k-means/patch/obs.raw.patch_pca'
printf,1,rd_2
close,1
;
return
end
;
; In order to get back to original data/units, you must keep:
; 1) the original means [mean(x), mean(y)]
; 2) the eigenvectors
; Remember that the result will still be standardized. See lines 9-20.
fd_2=rd - rebin([mean(x, /double), mean(y1, /double), mean(y2, /double), mean(y3, /double), mean(y4, /double)], 5, 83213)
array_2=transpose(fd_2) ## eigenvectors
tda2=transpose(array_2)
xmean2=tda2[*,0]
y1mean2=tda2[*,1]
y2mean2=tda2[*,2]
y3mean2=tda2[*,3]
y4mean2=tda2[*,4]
x_2=xmean2 + mean(x,/double)
y1_2=y1mean2 + mean(y1,/double)
y2_2=y2mean2 + mean(y2,/double)
y3_2=y3mean2 + mean(y3,/double)
y4_2=y4mean2 + mean(y4,/double)
print,'Difference between unaltered and unrotated data (should be approx zero):'
print,total(x_2-x),total(y1_2-y1),total(y2_2-y2),total(y3_2-y3),total(y4_2-y4)
; Unrotated Data
urot_orig_data=dblarr(3,83213)
urot_orig_data[0,*]=transpose(x_2)
urot_orig_data[1,*]=transpose(y1_2)
urot_orig_data[2,*]=transpose(y2_2)
;urot_orig_data[3,*]=transpose(y3_2)
;urot_orig_data[4,*]=transpose(y4_2)
openw,1,'~/clust/k-means/patch/obs.raw.patch_pca'
printf,1,urot_orig_data
close,1
;
