; Null hypothesis 1 of mdiv mesoscale diversity. correlations between 
; measures of diversity and other ecosystem parameters are the result 
; of analytical chance introduced by the k-means algorithm. To test 
; this, the following script finds the correlation for alpha/beta and 
; the results (habitat assignments) from the random seed k-means clusters.
; Alpha diversity: the number of unique genus names for each geographical 
; 1-degree grid cell.
; Beta diversity: the number of unique genus names for each geographical 
; 1-degree grid cell that do not occur in its neighboring cell, divided 
; by the total number of unique genus names (beta diversity ranges from 
; 0:1). The beta diversity of each grid cell is taken as the mean of the 
; beta diversities between each of the (n <= 8) non-null cells 8 
; surrounding it.
pro rs_test

;Read in data
;openr,1,'data/mdiv_patch.dat'
;data=dblarr(17,83213)
;readf,1,data
;close,1

openr,1,'data/mdiv_patch_rs.dat'
data=dblarr(102,83213)
readf,1,data
close,1

openr,1,'data/gnames.dat'
taxa=strarr(1,83213)
readf,1,taxa
close,1

nlon=360L
nlat=180L

print,'Testing null hypo #1 (analytical chance)'
print,'All correlations represent different random seed trials'
print,''
print,'Searching entire Cenozoic'
;clust_num_40=data[ 2,* ]
;
; count number of patches from random seed trials
for i=0,99 do begin
   lat=data[ 0,* ]
   lon=data[ 1,* ]
   clust_num_40=data[ strtrim(string(i+2),2),* ]
   names=taxa[ 0,* ]
   x=dindgen(nlon)-179.5
   y=dindgen(nlat)-89.5
   zc=lonarr(nlon,nlat)
   tc=lonarr(nlon,nlat)
   p40=lonarr(nlon,nlat)
   print,'Searching Random Seed Trial '+strtrim(string(i+1))
   for mlon=0,nlon-1 do begin
      for mlat=0,nlat-1 do begin
         ttmp = gstring(lon,lat,names,x[mlon],y[mlat])
         idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
         ; tc is the number of unique genus/class names
         if cnt gt 0 then begin
            ctemp_40=clust_num_40[idx]
            tc[mlon,mlat]=n_elements(ttmp)
            p40[mlon,mlat]=n_elements(ctemp_40[uniq(ctemp_40, sort(ctemp_40))])
            ;print,x[mlon],y[mlat],tc[mlon,mlat],p40[mlon,mlat]
         endif
      endfor ; mlat
   endfor ; mlon
   idx=where(tc gt 0,cnt)
   print,'Count:',cnt
   tc=tc[idx]
   p40=p40[idx]
   max_p40=max(p40,min=min_p40)
   tc_p40_pcorr=correlate(tc,p40,/double)
   tc_p40_rcorr=r_correlate(tc,p40)
   print,'Pearson Corr: Alpha Div. & p40_'+strtrim(string(i+1),2),tc_p40_pcorr
   print,'Spearman Corr: Alpha Div. & p40_'+strtrim(string(i+1),2),tc_p40_rcorr
   ; write data
endfor
;   openw,1,/append,'out/mdiv_rst.out'
;   printf,1,'Pearson Corr: Alpha Div. & Habitats40_'+strtrim(string(i+1),2),tc_p40_pcorr
;   printf,1,'Spearman Corr: Alpha Div. & Habitats40_'+strtrim(string(i+1),2),tc_p40_rcorr
;   close,1
;   print,''
;
return
end
